#pragma once

#include "messagebasic_global.h"
#include <simsbasic.h>
#include <standardglobe.h>

#define NAME(v) #v
#define DOUBLE_SAVE(u) obj[NAME(u)] = u
#define DOUOBLE_PEAK(u) u = obj[NAME(u)].toDouble()

/// <summary>
/// 
/// </summary>
class MESSAGEBASIC_EXPORT DeduceRequest : public WsMessage {
private:
	uint64_t _from_id = 0, _to_id = 0;

public:
	DeduceRequest();

	void reset(uint64_t from, uint64_t to);

	// ͨ WsMessage ̳
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
	QString topicString() const override;
	uint64_t targetEntity() const override;
	uint64_t sourceEntity() const override;
};

/// <summary>
/// Ĭϵ޷ϢĴͨ÷Ϣ
/// </summary>
class MESSAGEBASIC_EXPORT RespondDefault : public WsMessage {
private:
	uint64_t _from_id = 0, _to_id = 0;
	double _time_consume;

public:
	RespondDefault();

	void reset(uint64_t from, uint64_t to, double consume);

	double consume() const;

	// ͨ WsMessage ̳
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
	QString topicString() const override;
	uint64_t targetEntity() const override;
	uint64_t sourceEntity() const override;
};

/// <summary>
/// ʱͬϢ
/// </summary>
class MESSAGEBASIC_EXPORT SyncRequest : public WsMessage {
private:
	uint64_t _from_id = 0, _to_id = 0;
	double _time_current;

public:
	SyncRequest();

	void reset(uint64_t from, uint64_t to, double timepoint);

	// ͨ WsMessage ̳
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
	QString topicString() const override;
	uint64_t targetEntity() const override;
	uint64_t sourceEntity() const override;
};

// пӻϢ =======================================================
/// <summary>
/// ȡϸ
/// </summary>
class MESSAGEBASIC_EXPORT Get3DBox : public WsMessage {
private:
	uint64_t _from_id = 0, _to_id = 0;

public:
	Get3DBox();

	void reset(uint64_t from, uint64_t to);

	// ͨ WsMessage ̳
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
	QString topicString() const override;
	uint64_t targetEntity() const override;
	uint64_t sourceEntity() const override;
};

/// <summary>
/// ̬ݽṹ
/// </summary>
struct Posture {
	double _azimuth_deg = 0;
	double _pitch_deg = 0;
	double _roll_deg = 0;
};
/// <summary>
/// άݽṹ
/// </summary>
struct D3Data{
	double _length_m = 0;
	double _width_m = 0;
	double _height_m = 0;
};

/// <summary>
/// ϸݶ
/// </summary>
class MESSAGEBASIC_EXPORT Box3DDesc : public WsMessage {
private:
	uint64_t _from_id = 0, _to_id = 0;
	D3Data _d3_data;
	Posture _posture_d3;
	LLAPos _lla_pos;

public:
	Box3DDesc();

	void setTarget(uint64_t from, uint64_t to);
	void setVolume(const D3Data &d);
	D3Data volume() const;
	void setPosture(const Posture &p);
	Posture posture() const;
	void setPosition(const LLAPos &lla);
	LLAPos position() const;


	// ͨ WsMessage ̳
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
	QString topicString() const override;
	uint64_t targetEntity() const override;
	uint64_t sourceEntity() const override;
};
